## carl9170fw 1.9.9-399

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

project(carl9170)

#if you don't want the full compiler output, remove the following line
#set(CMAKE_VERBOSE_MAKEFILE ON)

include("config.cmake")

add_subdirectory(carlfw)

if (CONFIG_CARL9170FW_BUILD_MINIBOOT)
	add_subdirectory(minifw)
endif (CONFIG_CARL9170FW_BUILD_MINIBOOT)

if (CONFIG_CARL9170FW_BUILD_TOOLS)
	add_subdirectory(tools)
endif (CONFIG_CARL9170FW_BUILD_TOOLS)

=== carlfw/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(carl9170.fw)

include("../extra/sh-elf-linux.cmake")
include("../config.cmake")

set(CARL9170_FW_ELF carl9170.elf)
set(CARLFW_CFLAGS_WARNING "-W -Wall -Wextra -Wunreachable-code -Winline -Wlogical-op -Wno-packed-bitfield-compat -Winit-self -Wshadow -Wwrite-strings -Waggregate-return -Wstrict-prototypes -Wformat=2 -Wcast-align -Wmissing-format-attribute -Wmissing-prototypes -Wtype-limits -Wmissing-declarations -Wmissing-noreturn -Wredundant-decls -Wnested-externs -Wdisabled-optimization -Wpointer-arith -Wvolatile-register-var -Waddress -Wbad-function-cast -Wunsafe-loop-optimizations")
set(CARLFW_CFLAGS_EXTRA "-mbitops -ffunction-sections -Wframe-larger-than=128 -Werror")
set(CARLFW_CFLAGS_DEF "-D__CARL9170FW__")
if (CONFIG_CARL9170FW_AGGRESSIVE_CFLAGS)
	set(CARLFW_CFLAGS_AGGRESSIVE "-fomit-frame-pointer -fsee -frename-registers -ftree-vectorize -flto -fstrict-volatile-bitfields -fmodulo-sched -fwhole-program")
endif (CONFIG_CARL9170FW_AGGRESSIVE_CFLAGS)
set(CARLFW_CFLAGS "${CARLFW_CFLAGS_DEF} ${CARLFW_CFLAGS_EXTRA} ${CARLFW_CFLAGS_AGGRESSIVE} ${CARLFW_CFLAGS_WARNING}")

include_directories (../include/linux ../include/shared ../include include)

set(carl9170_main_src src/main.c src/wlan.c src/wlanrx.c src/wlantx.c
		      src/fw.c src/gpio.c src/timer.c
		      src/uart.c src/dma.c src/hostif.c src/reboot.S
		      src/printf.c src/rf.c src/cam.c src/wol.c)

set(carl9170_lib_src src/memcpy.S src/memset.S src/udivsi3_i4i-Os.S)
set(carl9170_usb_src usb/main.c usb/usb.c usb/fifo.c)

set(carl9170_src ${carl9170_main_src} ${carl9170_lib_src} ${carl9170_usb_src})

#set_source_files_properties(src/ashlsi3.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/memcpy.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/memset.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/reboot.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/udivsi3_i4i-Os.S PROPERTIES LANGUAGE C)

add_executable(carl9170.elf ${carl9170_src})

set_target_properties(carl9170.elf PROPERTIES LINKER_LANGUAGE C)

set_target_properties(carl9170.elf PROPERTIES COMPILE_FLAGS "${CARLFW_CFLAGS}")
set_target_properties(carl9170.elf PROPERTIES LINK_FLAGS "${CARLFW_CFLAGS} -Wl,-Tcarl9170.lds")

add_custom_target(firmware ALL DEPENDS carl9170.elf)

add_custom_command(
	DEPENDS carl9170.elf
	COMMAND ${OBJCOPY}
	ARGS --strip-unneeded -O binary -R .sram -R .eeprom -R .fwdsc carl9170.elf carl9170.bin
	TARGET firmware
	BYPRODUCTS carl9170.bin
	OUTPUTS carl9170.bin)

add_custom_command(
	DEPENDS carl9170.elf
	COMMAND ${OBJCOPY}
	ARGS --strip-unneeded -O binary -j .fwdsc carl9170.elf carl9170.dsc
	TARGET firmware
	BYPRODUCTS carl9170.dsc
	OUTPUTS carl9170.dsc)

add_custom_command(
	DEPENDS firmware
	TARGET firmware
	COMMAND cat
	ARGS "carl9170.bin" "carl9170.dsc" > "carl9170.fw"
	DEPENDS carl9170.elf carl9170.bin carl9170.dsc
	OUTPUTS carl9170.fw)

SET_DIRECTORY_PROPERTIES(
	PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "carl9170.fw")

=== config/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

project(config)

#set(CMAKE_VERBOSE_MAKEFILE ON)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(MAKE_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../include/generated")

BISON_TARGET(parser parser.y parser.tab.c COMPILE_FLAGS "-l -b parser -p yy -t")
FLEX_TARGET(lexer lexer.l lexer.lex.c COMPILE_FLAGS "-Pyy -L")

SET(parser_deps ${FLEX_lexer_OUTPUTS})
SET_SOURCE_FILES_PROPERTIES(${BISON_parser_OUTPUTS}
      PROPERTIES OBJECT_DEPENDS "${parser_deps}")

set(conf_src conf.c util.c symbol.c confdata.c expr.c preprocess.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})

add_executable(conf ${conf_src})

=== minifw/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(miniboot.fw)

include("../extra/sh-elf-linux.cmake")
include("../config.cmake")

set(miniboot_src miniboot.S)
set_source_files_properties(miniboot.S PROPERTIES LANGUAGE C)

add_executable(miniboot.elf miniboot.S)

set_target_properties(miniboot.elf PROPERTIES LINKER_LANGUAGE C)

set_target_properties(miniboot.elf PROPERTIES LINK_FLAGS "-Tminiboot.lds")

add_custom_target(
	miniboot.fw ALL
	${OBJCOPY} --strip-unneeded -O binary -R .sram -R .eeprom -R .fwdsc miniboot.elf miniboot.fw
	DEPENDS miniboot.elf
	BYPRODUCTS miniboot.fw)

=== toolchain/Makefile ===
BINUTILS_VER=2.37
BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.xz
BINUTILS_URL="http://mirrors.kernel.org/gnu/binutils/$(BINUTILS_TAR)"

NEWLIB_VER=4.1.0
NEWLIB_TAR=newlib-$(NEWLIB_VER).tar.gz
NEWLIB_URL="ftp://sourceware.org/pub/newlib/$(NEWLIB_TAR)"

GCC_VER=11.2.0
GCC_TAR=gcc-$(GCC_VER).tar.xz
GCC_URL="http://mirrors.kernel.org/gnu/gcc/gcc-$(GCC_VER)/$(GCC_TAR)"

MPFR_VER=4.1.0
MPFR_TAR=mpfr-$(MPFR_VER).tar.xz
MPFR_URL="http://ftpmirror.gnu.org/gnu/mpfr/$(MPFR_TAR)"

GMP_VER=6.2.1
GMP_TAR=gmp-$(GMP_VER).tar.xz
GMP_URL="http://ftpmirror.gnu.org/gnu/gmp/$(GMP_TAR)"

MPC_VER=1.2.1
MPC_TAR=mpc-$(MPC_VER).tar.gz
MPC_URL="http://ftpmirror.gnu.org/gnu/mpc/$(MPC_TAR)"

JOBS?=$(shell grep -c ^processor /proc/cpuinfo)

BASEDIR=$(shell pwd)

define checksum
@if grep -q '  $(subst .,\.,$(1))$$' SHA256SUMS; then			\
	grep '  $(subst .,\.,$(1))$$' SHA256SUMS | sha256sum -c || rm $(1);	\
else									\
	echo "WARNING: no checksum defined for $(1)";			\
fi
endef

all: clean gcc

src/$(MPFR_TAR):
	wget -P "$(BASEDIR)/src" "$(MPFR_URL)"
	$(call checksum,$@)

src/$(GMP_TAR):
	wget -P "$(BASEDIR)/src" "$(GMP_URL)"
	$(call checksum,$@)

src/$(MPC_TAR):
	wget -P "$(BASEDIR)/src" "$(MPC_URL)"
	$(call checksum,$@)

src/$(BINUTILS_TAR):
	wget -P "$(BASEDIR)/src" "$(BINUTILS_URL)"
	$(call checksum,$@)

src/$(NEWLIB_TAR):
	wget -P "$(BASEDIR)/src" "$(NEWLIB_URL)"
	$(call checksum,$@)

src/$(GCC_TAR):
	wget -P "$(BASEDIR)/src" "$(GCC_URL)"
	$(call checksum,$@)

src/mpfr-$(MPFR_VER): src/$(MPFR_TAR)
	tar -C "$(BASEDIR)/src" -xf "$<"

src/gmp-$(GMP_VER): src/$(GMP_TAR)
	tar -C "$(BASEDIR)/src" -xf "$<"

src/mpc-$(MPC_VER): src/$(MPC_TAR)
	tar -C "$(BASEDIR)/src" -xf "$<"

src/binutils-$(BINUTILS_VER): src/$(BINUTILS_TAR)
	tar -C "$(BASEDIR)/src" -xf "$<"

src/newlib-$(NEWLIB_VER): src/$(NEWLIB_TAR)
	tar -C "$(BASEDIR)/src" -xf "$<"

src/gcc-$(GCC_VER): src/$(GCC_TAR) src/newlib-$(NEWLIB_VER) src/mpc-$(MPC_VER) src/gmp-$(GMP_VER) src/mpfr-$(MPFR_VER)
	tar -C "$(BASEDIR)/src" -xf "$<"
	ln -s "$(BASEDIR)/src/newlib-$(NEWLIB_VER)/newlib" "$@"
	ln -s "$(BASEDIR)/src/newlib-$(NEWLIB_VER)/libgloss" "$@"
	ln -s "$(BASEDIR)/src/gmp-$(GMP_VER)" "$@/gmp"
	ln -s "$(BASEDIR)/src/mpfr-$(MPFR_VER)" "$@/mpfr"
	ln -s "$(BASEDIR)/src/mpc-$(MPC_VER)" "$@/mpc"

binutils: src/binutils-$(BINUTILS_VER)
	mkdir -p "$(BASEDIR)/build/binutils"
	cd "$(BASEDIR)/build/binutils"; \
	"$(BASEDIR)"/$</configure --target=sh-elf --prefix="$(BASEDIR)/inst"; \
	$(MAKE) -j$(JOBS); \
	$(MAKE) install

gcc: src/gcc-$(GCC_VER) binutils
	mkdir -p "$(BASEDIR)/build/gcc"
	cd "$(BASEDIR)/build/gcc"; \
	"$(BASEDIR)"/$</configure --target=sh-elf --prefix="$(BASEDIR)/inst" -enable-languages=c --without-pkgversion --with-newlib; \
	$(MAKE) -j$(JOBS); \
	$(MAKE) install

clean:
	rm -rf "$(BASEDIR)/build" "$(BASEDIR)/inst"

distclean: clean
	rm -rf "$(BASEDIR)/src"

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(tools)

if (CONFIG_CARL9170FW_MAKE_RELEASE)
	set(CMAKE_BUILD_TYPE Release)
endif (CONFIG_CARL9170FW_MAKE_RELEASE)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/extra)

include("../config.cmake")

include_directories (../include/linux ../include/shared ../include lib include)
add_subdirectory(lib)
add_subdirectory(src)

=== tools/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(tools)

add_custom_target(wol ALL COMMAND gcc wol.c -o wol)

set(tools fwinfo miniboot checksum)

foreach(tool ${tools})
	add_executable( ${tool} ${tool}.c )
	add_definitions("-Wall -Wextra -Wshadow")
	target_link_libraries( ${tool} carlfw )
endforeach()

## carl9170fw 1.9.9-399-gcd480b9

=== debian/changelog ===
carl9170fw (1.9.9-399-gcd480b9-1.2) unstable; urgency=medium

  * Non-maintainer upload
  * Move firmware to /usr hierarchy
  * Conflict on next firmware-linux-free revision (Closes: #1050989)

 -- Bastian Germann <bage@debian.org>  Wed, 05 Jun 2024 21:58:15 +0000

carl9170fw (1.9.9-399-gcd480b9-1.1) experimental; urgency=medium

  * Non-maintainer upload
  * Prevent executing dh_gencontrol on dropped udeb
  * Fix dual-licensed files with Atheros copyright
  * DEP-11: Add metainfo.xml with firmware provides (Closes: #1051266)

  [ John Scott ]
  * Static-Built-Using is no substitute for Built-Using
  * Change a makefile convention in debian/rules and drop the udeb package

 -- Bastian Germann <bage@debian.org>  Tue, 05 Sep 2023 13:45:59 +0000

carl9170fw (1.9.9-399-gcd480b9-1) experimental; urgency=medium

  * Initial release (Closes: #994625)

 -- John Scott <jscott@posteo.net>  Sat, 25 Dec 2021 12:23:08 -0500

=== debian/watch ===
version=4
opts="dversionmangle=auto, mode=git, uversionmangle=s/(\d\.\d\.\d)\.(.+)\.(.+)/$1-$2-$3/, pretty=describe" \
	https://github.com/chunkeey/@PACKAGE@.git HEAD debian

## carl9170fw 1.9.9-450

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.4)
+cmake_minimum_required(VERSION 3.0)
 
 project(carl9170)

=== carlfw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 
 project(carl9170.fw)

=== config/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.4)
+cmake_minimum_required(VERSION 3.0)
 
 project(config)

=== minifw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 
 project(miniboot.fw)

=== toolchain/Makefile ===
--- 
+++ 
@@ -1,16 +1,16 @@
-BINUTILS_VER=2.37
+BINUTILS_VER=2.40
 BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.xz
 BINUTILS_URL="http://mirrors.kernel.org/gnu/binutils/$(BINUTILS_TAR)"
 
-NEWLIB_VER=4.1.0
+NEWLIB_VER=4.3.0.20230120
 NEWLIB_TAR=newlib-$(NEWLIB_VER).tar.gz
 NEWLIB_URL="ftp://sourceware.org/pub/newlib/$(NEWLIB_TAR)"
 
-GCC_VER=11.2.0
+GCC_VER=13.1.0
 GCC_TAR=gcc-$(GCC_VER).tar.xz
 GCC_URL="http://mirrors.kernel.org/gnu/gcc/gcc-$(GCC_VER)/$(GCC_TAR)"
 
-MPFR_VER=4.1.0
+MPFR_VER=4.2.0
 MPFR_TAR=mpfr-$(MPFR_VER).tar.xz
 MPFR_URL="http://ftpmirror.gnu.org/gnu/mpfr/$(MPFR_TAR)"
 
@@ -18,7 +18,7 @@
 GMP_TAR=gmp-$(GMP_VER).tar.xz
 GMP_URL="http://ftpmirror.gnu.org/gnu/gmp/$(GMP_TAR)"
 
-MPC_VER=1.2.1
+MPC_VER=1.3.1
 MPC_TAR=mpc-$(MPC_VER).tar.gz
 MPC_URL="http://ftpmirror.gnu.org/gnu/mpc/$(MPC_TAR)"

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 
 project(tools)

=== tools/lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(libcarlfw)

set(carlfw_src carlfw.c)

add_library( carlfw STATIC ${carlfw_src})

=== tools/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 
 project(tools)

## carl9170fw 1.9.9-450-gad1c721+dfsg

=== debian/changelog ===
carl9170fw (1.9.9-450-gad1c721+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload

  [ John Scott ]
  * New upstream version (Closes: #1091146)

  [ Ben Hutchings ]
  * d/salsa-ci.yml: Add CI configuration for salsa.debian.org
  * Exclude tools/src/eeprom_fix binary from upstream source
  * d/copyright: Add entry for upstream metainfo.xml

 -- Bastian Germann <bage@debian.org>  Sun, 05 Jan 2025 15:18:11 +0000

=== debian/control ===
Source: carl9170fw
Section: kernel
Priority: optional
Maintainer: John Scott <jscott@posteo.net>
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 flex,
 gcc-sh-elf,
 libnewlib-sh-elf-dev
Standards-Version: 4.6.0
Homepage: https://wireless.wiki.kernel.org/en/users/Drivers/carl9170
Vcs-Browser: https://salsa.debian.org/kernel-team/carl9170fw
Vcs-Git: https://salsa.debian.org/kernel-team/carl9170fw.git
Rules-Requires-Root: no

Package: firmware-carl9170
Architecture: all
Depends: ${misc:Depends}
Conflicts: firmware-linux-free (<< 20200122-5)
Built-Using: ${gcc-built-using}, newlib (= ${newlib-source-version})
Description: firmware for AR9170 USB wireless adapters
 This is the carl9170 firmware for Qualcomm Atheros AR9170
 802.11n USB wireless adapters. This gets loaded onto the
 device during use, and is intended to be used in conjunction
 with the carl9170 driver.

=== debian/watch ===
version=4
opts="dversionmangle=auto, mode=git, repacksuffix=+dfsg, dversionmangle=auto, uversionmangle=s/(\d\.\d\.\d)\.(.+)\.(.+)/$1-$2-$3/, pretty=describe" \
	https://github.com/chunkeey/@PACKAGE@.git HEAD debian

## carl9170fw 1.9.9-686

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(carl9170)

=== carlfw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(carl9170.fw)
 
@@ -42,6 +42,7 @@
 add_custom_target(firmware ALL DEPENDS carl9170.elf)
 
 add_custom_command(
+	POST_BUILD
 	DEPENDS carl9170.elf
 	COMMAND ${OBJCOPY}
 	ARGS --strip-unneeded -O binary -R .sram -R .eeprom -R .fwdsc carl9170.elf carl9170.bin
@@ -50,6 +51,7 @@
 	OUTPUTS carl9170.bin)
 
 add_custom_command(
+	POST_BUILD
 	DEPENDS carl9170.elf
 	COMMAND ${OBJCOPY}
 	ARGS --strip-unneeded -O binary -j .fwdsc carl9170.elf carl9170.dsc
@@ -58,6 +60,7 @@
 	OUTPUTS carl9170.dsc)
 
 add_custom_command(
+	POST_BUILD
 	DEPENDS firmware
 	TARGET firmware
 	COMMAND cat

=== config/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(config)
 
@@ -18,6 +18,6 @@
 SET_SOURCE_FILES_PROPERTIES(${BISON_parser_OUTPUTS}
       PROPERTIES OBJECT_DEPENDS "${parser_deps}")
 
-set(conf_src conf.c util.c symbol.c confdata.c expr.c preprocess.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})
+set(conf_src conf.c util.c symbol.c confdata.c expr.c preprocess.c menu.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})
 
 add_executable(conf ${conf_src})

=== minifw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(miniboot.fw)

=== toolchain/Makefile ===
--- 
+++ 
@@ -1,20 +1,20 @@
-BINUTILS_VER=2.40
+BINUTILS_VER=2.45
 BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.xz
 BINUTILS_URL="http://mirrors.kernel.org/gnu/binutils/$(BINUTILS_TAR)"
 
-NEWLIB_VER=4.3.0.20230120
+NEWLIB_VER=4.5.0.20241231
 NEWLIB_TAR=newlib-$(NEWLIB_VER).tar.gz
 NEWLIB_URL="ftp://sourceware.org/pub/newlib/$(NEWLIB_TAR)"
 
-GCC_VER=13.1.0
+GCC_VER=15.2.0
 GCC_TAR=gcc-$(GCC_VER).tar.xz
 GCC_URL="http://mirrors.kernel.org/gnu/gcc/gcc-$(GCC_VER)/$(GCC_TAR)"
 
-MPFR_VER=4.2.0
+MPFR_VER=4.2.2
 MPFR_TAR=mpfr-$(MPFR_VER).tar.xz
 MPFR_URL="http://ftpmirror.gnu.org/gnu/mpfr/$(MPFR_TAR)"
 
-GMP_VER=6.2.1
+GMP_VER=6.3.0
 GMP_TAR=gmp-$(GMP_VER).tar.xz
 GMP_URL="http://ftpmirror.gnu.org/gnu/gmp/$(GMP_TAR)"

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(tools)

=== tools/lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(libcarlfw)

=== tools/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 project(tools)

## carl9170fw 1.9.9-686-ge7ba7bf+dfsg

=== debian/changelog ===
carl9170fw (1.9.9-686-ge7ba7bf+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version (Closes: #1112763)
  * Fix Homepage (Closes: #1116028)

 -- Bastian Germann <bage@debian.org>  Mon, 06 Oct 2025 11:49:11 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  gcc-sh-elf,
  libnewlib-sh-elf-dev
 Standards-Version: 4.6.0
-Homepage: https://wireless.wiki.kernel.org/en/users/Drivers/carl9170
+Homepage: https://wireless.docs.kernel.org/en/latest/en/users/drivers/carl9170.fw.html
 Vcs-Browser: https://salsa.debian.org/kernel-team/carl9170fw
 Vcs-Git: https://salsa.debian.org/kernel-team/carl9170fw.git
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/buildopts.mk
DEB_BUILD_OPTION_PARALLEL ?= 1

%:
	dh $@ --builddirectory=carl9170-build

# The procedure for building the firmware was determined by
# examining autogen.sh. The build system doesn't cope well
# with us building in a subdirectory, so we need a few tricks
# to make it work.

.config execute_before_dh_auto_configure:
# This is where the build system expects to find the tools.
	mkdir -p toolchain/inst/bin
	cd toolchain/inst/bin && \
		for i in /usr/bin/sh-elf-*; \
		do ln -sf "$$i" `basename "$$i"`; \
		done
	if ! [ -d config-build ]; \
	then cp -r config config-build; \
	fi
	cd config-build && \
		cmake -G "Unix Makefiles" . && \
		make -j$(DEB_BUILD_OPTION_PARALLEL)
	config-build/conf --alldefconfig Kconfig

execute_before_dh_auto_build:
	for i in carlfw/carl9170.lds minifw/miniboot.lds tools/src/wol.c; \
	do \
		mkdir -p `dirname carl9170-build/"$$i"`; \
		cp "$$i" carl9170-build/"$$i"; \
	done

execute_after_dh_auto_build:
	carl9170-build/tools/src/miniboot a carl9170-build/carlfw/carl9170.fw carl9170-build/minifw/miniboot.fw

execute_before_dh_install:
	if [ -e carl9170-build/carlfw/carl9170.fw ]; \
	then mv carl9170-build/carlfw/carl9170.fw carl9170-build/carlfw/carl9170-1.fw; \
	fi

override_dh_gencontrol:
	for i in firmware-carl9170; \
	do \
		dh_gencontrol -p "$$i" -- -Vgcc-built-using="$(shell dpkg-query -Wf'$${Built-Using}\n' gcc-sh-elf | cut -d ',' -f 1)" \
			-Vnewlib-source-version=`dpkg-query -Wf'$${Built-Using-Newlib-Source}\n' libnewlib-sh-elf-dev | cut -d ':' -f 2`; \
	done

## carl9170fw 1.9.9-690

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(carl9170)

=== carlfw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(carl9170.fw)
 
@@ -43,30 +43,14 @@
 
 add_custom_command(
 	POST_BUILD
-	DEPENDS carl9170.elf
+	TARGET firmware
 	COMMAND ${OBJCOPY}
 	ARGS --strip-unneeded -O binary -R .sram -R .eeprom -R .fwdsc carl9170.elf carl9170.bin
-	TARGET firmware
-	BYPRODUCTS carl9170.bin
-	OUTPUTS carl9170.bin)
-
-add_custom_command(
-	POST_BUILD
-	DEPENDS carl9170.elf
 	COMMAND ${OBJCOPY}
 	ARGS --strip-unneeded -O binary -j .fwdsc carl9170.elf carl9170.dsc
-	TARGET firmware
-	BYPRODUCTS carl9170.dsc
-	OUTPUTS carl9170.dsc)
-
-add_custom_command(
-	POST_BUILD
-	DEPENDS firmware
-	TARGET firmware
 	COMMAND cat
 	ARGS "carl9170.bin" "carl9170.dsc" > "carl9170.fw"
-	DEPENDS carl9170.elf carl9170.bin carl9170.dsc
-	OUTPUTS carl9170.fw)
+	BYPRODUCTS carl9170.bin carl9170.dsc carl9170.fw)
 
 SET_DIRECTORY_PROPERTIES(
 	PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "carl9170.fw")

=== minifw/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(miniboot.fw)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(tools)

=== tools/lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(libcarlfw)

=== tools/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project(tools)

## carl9170fw 1.9.9-690-gc6e7ab0

=== debian/changelog ===
carl9170fw (1.9.9-690-gc6e7ab0-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * Build without branch hardening (Closes: #1123920)

 -- Bastian Germann <bage@debian.org>  Wed, 24 Dec 2025 01:26:58 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 include /usr/share/dpkg/buildopts.mk
 DEB_BUILD_OPTION_PARALLEL ?= 1
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=-branch
 
 %:
 	dh $@ --builddirectory=carl9170-build

=== debian/watch ===
version=4
opts="dversionmangle=auto, mode=git, dversionmangle=auto, uversionmangle=s/(\d\.\d\.\d)\.(.+)\.(.+)/$1-$2-$3/, pretty=describe" \
	https://github.com/chunkeey/@PACKAGE@.git HEAD debian
